/**
 *  Copyright (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  Licensed under the GPL, Version 3.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/gpl.html
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * --------------------------------------------------------------------------
 *  版权 (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  本开源软件遵循 GPL 3.0 协议;
 *  如果您不遵循此协议，则不被允许使用此文件。
 *  你可以从下面的地址获取完整的协议文本
 *
 *       http://www.gnu.org/licenses/gpl.html
 */
package org.tinygroup.reloader;

import java.lang.instrument.Instrumentation;

/**
 * Class responsible for the intialization of the agent.
 *
 * @author Antonio S. R. Gomes
 */
public class Agent {

	static Transformer t;
	static Instrumentation inst;

	/**
	 * Premain method called before the target application is initialized.
	 *
	 * @param args command line argument passed via <code>-javaagent</code>
	 * @param inst instance of the instrumentation service
	 */
	public static void premain(String args, Instrumentation inst) {
		Logger logger = new Logger(Agent.class.getName());
		logger.error("+---------------------------------------------------+");
		logger.error("| Hundsun Reloader Agent "
				+ String.format("%-34s", Version.VERSION) + "|");
		System.err.println("| Copyright 1995,2012            |");
		System.err
				.println("+---------------------------------------------------+");

		Agent.inst = inst;
		t = new Transformer();
		inst.addTransformer(t);
	}

}
